Index: uspace/lib/usbhost/src/hcd.c
===================================================================
--- uspace/lib/usbhost/src/hcd.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usbhost/src/hcd.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -49,5 +49,5 @@
  * @return Error code.
  */
-static errno_t register_helper(endpoint_t *ep, void *arg)
+static int register_helper(endpoint_t *ep, void *arg)
 {
 	hcd_t *hcd = arg;
@@ -102,11 +102,16 @@
 }
 
-errno_t hcd_request_address(hcd_t *hcd, usb_speed_t speed, usb_address_t *address)
-{
-	assert(hcd);
-	return usb_bus_request_address(&hcd->bus, address, false, speed);
-}
-
-errno_t hcd_release_address(hcd_t *hcd, usb_address_t address)
+usb_address_t hcd_request_address(hcd_t *hcd, usb_speed_t speed)
+{
+	assert(hcd);
+	usb_address_t address = 0;
+	const int ret = usb_bus_request_address(
+	    &hcd->bus, &address, false, speed);
+	if (ret != EOK)
+		return ret;
+	return address;
+}
+
+int hcd_release_address(hcd_t *hcd, usb_address_t address)
 {
 	assert(hcd);
@@ -115,5 +120,5 @@
 }
 
-errno_t hcd_reserve_default_address(hcd_t *hcd, usb_speed_t speed)
+int hcd_reserve_default_address(hcd_t *hcd, usb_speed_t speed)
 {
 	assert(hcd);
@@ -122,5 +127,5 @@
 }
 
-errno_t hcd_add_ep(hcd_t *hcd, usb_target_t target, usb_direction_t dir,
+int hcd_add_ep(hcd_t *hcd, usb_target_t target, usb_direction_t dir,
     usb_transfer_type_t type, size_t max_packet_size, unsigned packets,
     size_t size, usb_address_t tt_address, unsigned tt_port)
@@ -132,5 +137,5 @@
 }
 
-errno_t hcd_remove_ep(hcd_t *hcd, usb_target_t target, usb_direction_t dir)
+int hcd_remove_ep(hcd_t *hcd, usb_target_t target, usb_direction_t dir)
 {
 	assert(hcd);
@@ -147,5 +152,5 @@
 } toggle_t;
 
-static void toggle_reset_callback(errno_t retval, void *arg)
+static void toggle_reset_callback(int retval, void *arg)
 {
 	assert(arg);
@@ -172,5 +177,5 @@
  * @return Error code.
  */
-errno_t hcd_send_batch(
+int hcd_send_batch(
     hcd_t *hcd, usb_target_t target, usb_direction_t direction,
     void *data, size_t size, uint64_t setup_data,
@@ -232,5 +237,5 @@
 	}
 
-	const errno_t ret = hcd->ops.schedule(hcd, batch);
+	const int ret = hcd->ops.schedule(hcd, batch);
 	if (ret != EOK)
 		usb_transfer_batch_destroy(batch);
@@ -244,9 +249,9 @@
 typedef struct {
 	volatile unsigned done;
-	errno_t ret;
+	int ret;
 	size_t size;
 } sync_data_t;
 
-static void transfer_in_cb(errno_t ret, size_t size, void* data)
+static void transfer_in_cb(int ret, size_t size, void* data)
 {
 	sync_data_t *d = data;
@@ -257,5 +262,5 @@
 }
 
-static void transfer_out_cb(errno_t ret, void* data)
+static void transfer_out_cb(int ret, void* data)
 {
 	sync_data_t *d = data;
@@ -266,12 +271,12 @@
 
 /** this is really ugly version of sync usb communication */
-errno_t hcd_send_batch_sync(
+ssize_t hcd_send_batch_sync(
     hcd_t *hcd, usb_target_t target, usb_direction_t dir,
-    void *data, size_t size, uint64_t setup_data, const char* name, size_t *out_size)
+    void *data, size_t size, uint64_t setup_data, const char* name)
 {
 	assert(hcd);
 	sync_data_t sd = { .done = 0, .ret = EBUSY, .size = size };
 
-	const errno_t ret = hcd_send_batch(hcd, target, dir, data, size, setup_data,
+	const int ret = hcd_send_batch(hcd, target, dir, data, size, setup_data,
 	    dir == USB_DIRECTION_IN ? transfer_in_cb : NULL,
 	    dir == USB_DIRECTION_OUT ? transfer_out_cb : NULL, &sd, name);
@@ -284,5 +289,5 @@
 
 	if (sd.ret == EOK)
-		*out_size = sd.size;
+		return sd.size;
 	return sd.ret;
 }
Index: uspace/lib/usbhost/src/usb_bus.c
===================================================================
--- uspace/lib/usbhost/src/usb_bus.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usbhost/src/usb_bus.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -102,8 +102,7 @@
  *
  * @param[in] instance Device manager structure to use.
- * @param[out] address Free address.
- * @return Error code.
- */
-static errno_t usb_bus_get_free_address(usb_bus_t *instance, usb_address_t *address)
+ * @return Free address, or error code.
+ */
+static usb_address_t usb_bus_get_free_address(usb_bus_t *instance)
 {
 
@@ -120,6 +119,5 @@
 	instance->last_address = new_address;
 
-	*address = new_address;
-	return EOK;
+	return new_address;
 }
 
@@ -200,5 +198,5 @@
  * @return Error code.
  */
-errno_t usb_bus_init(usb_bus_t *instance,
+int usb_bus_init(usb_bus_t *instance,
     size_t available_bandwidth, bw_count_func_t bw_count, usb_speed_t max_speed)
 {
@@ -224,5 +222,5 @@
  * @return Error code.
  */
-errno_t usb_bus_register_ep(usb_bus_t *instance, endpoint_t *ep, size_t data_size)
+int usb_bus_register_ep(usb_bus_t *instance, endpoint_t *ep, size_t data_size)
 {
 	assert(instance);
@@ -262,5 +260,5 @@
  * @return Error code.
  */
-errno_t usb_bus_unregister_ep(usb_bus_t *instance, endpoint_t *ep)
+int usb_bus_unregister_ep(usb_bus_t *instance, endpoint_t *ep)
 {
 	assert(instance);
@@ -316,5 +314,5 @@
  * @return Error code.
  */
-errno_t usb_bus_add_ep(usb_bus_t *instance,
+int usb_bus_add_ep(usb_bus_t *instance,
     usb_address_t address, usb_endpoint_t endpoint, usb_direction_t direction,
     usb_transfer_type_t type, size_t max_packet_size, unsigned packets,
@@ -364,5 +362,5 @@
 
 	if (callback) {
-		const errno_t ret = callback(ep, arg);
+		const int ret = callback(ep, arg);
 		if (ret != EOK) {
 			fibril_mutex_unlock(&instance->guard);
@@ -394,5 +392,5 @@
  * @return Error code.
  */
-errno_t usb_bus_remove_ep(usb_bus_t *instance,
+int usb_bus_remove_ep(usb_bus_t *instance,
     usb_address_t address, usb_endpoint_t endpoint, usb_direction_t direction,
     ep_remove_callback_t callback, void *arg)
@@ -417,5 +415,5 @@
 }
 
-errno_t usb_bus_reset_toggle(usb_bus_t *instance, usb_target_t target, bool all)
+int usb_bus_reset_toggle(usb_bus_t *instance, usb_target_t target, bool all)
 {
 	assert(instance);
@@ -423,5 +421,5 @@
 		return EINVAL;
 
-	errno_t ret = ENOENT;
+	int ret = ENOENT;
 
 	fibril_mutex_lock(&instance->guard);
@@ -446,5 +444,5 @@
  * @return Error code.
  */
-errno_t usb_bus_remove_address(usb_bus_t *instance,
+int usb_bus_remove_address(usb_bus_t *instance,
     usb_address_t address, ep_remove_callback_t callback, void *arg)
 {
@@ -455,5 +453,5 @@
 	fibril_mutex_lock(&instance->guard);
 
-	const errno_t ret = instance->devices[address].occupied ? EOK : ENOENT;
+	const int ret = instance->devices[address].occupied ? EOK : ENOENT;
 	instance->devices[address].occupied = false;
 
@@ -476,10 +474,10 @@
 /** Request USB address.
  * @param instance usb_device_manager
- * @param[inout] address Pointer to requested address value, place to store new address
+ * @param address Pointer to requested address value, place to store new address
  * @parma strict Fail if the requested address is not available.
  * @return Error code.
  * @note Default address is only available in strict mode.
  */
-errno_t usb_bus_request_address(usb_bus_t *instance,
+int usb_bus_request_address(usb_bus_t *instance,
     usb_address_t *address, bool strict, usb_speed_t speed)
 {
@@ -493,14 +491,9 @@
 
 	usb_address_t addr = *address;
-	errno_t rc;
 
 	fibril_mutex_lock(&instance->guard);
 	/* Only grant default address to strict requests */
 	if ((addr == USB_ADDRESS_DEFAULT) && !strict) {
-		rc = usb_bus_get_free_address(instance, &addr);
-		if (rc != EOK) {
-			fibril_mutex_unlock(&instance->guard);
-			return rc;
-		}
+		addr = usb_bus_get_free_address(instance);
 	}
 
@@ -510,9 +503,5 @@
 			return ENOENT;
 		}
-		rc = usb_bus_get_free_address(instance, &addr);
-		if (rc != EOK) {
-			fibril_mutex_unlock(&instance->guard);
-			return rc;
-		}
+		addr = usb_bus_get_free_address(instance);
 	}
 	if (usb_address_is_valid(addr)) {
@@ -527,7 +516,5 @@
 
 	fibril_mutex_unlock(&instance->guard);
-
-	*address = addr;
-	return EOK;
+	return addr;
 }
 
@@ -539,5 +526,5 @@
  * @return Error code.
  */
-errno_t usb_bus_get_speed(usb_bus_t *instance, usb_address_t address,
+int usb_bus_get_speed(usb_bus_t *instance, usb_address_t address,
     usb_speed_t *speed)
 {
@@ -549,5 +536,5 @@
 	fibril_mutex_lock(&instance->guard);
 
-	const errno_t ret = instance->devices[address].occupied ? EOK : ENOENT;
+	const int ret = instance->devices[address].occupied ? EOK : ENOENT;
 	if (speed && instance->devices[address].occupied) {
 		*speed = instance->devices[address].speed;
Index: uspace/lib/usbhost/src/usb_transfer_batch.c
===================================================================
--- uspace/lib/usbhost/src/usb_transfer_batch.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usbhost/src/usb_transfer_batch.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -94,5 +94,5 @@
  * @param[in] instance Batch structure to use.
  */
-void usb_transfer_batch_destroy(usb_transfer_batch_t *instance)
+void usb_transfer_batch_destroy(const usb_transfer_batch_t *instance)
 {
 	if (!instance)
@@ -114,5 +114,5 @@
  */
 void usb_transfer_batch_finish_error(const usb_transfer_batch_t *instance,
-    const void *data, size_t size, errno_t error)
+    const void *data, size_t size, int error)
 {
 	assert(instance);
Index: uspace/lib/usbvirt/include/usbvirt/device.h
===================================================================
--- uspace/lib/usbvirt/include/usbvirt/device.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usbvirt/include/usbvirt/device.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -56,5 +56,5 @@
  * @return Error code.
  */
-typedef errno_t (*usbvirt_on_data_to_device_t)(usbvirt_device_t *dev,
+typedef int (*usbvirt_on_data_to_device_t)(usbvirt_device_t *dev,
     usb_endpoint_t endpoint, usb_transfer_type_t transfer_type,
     const void *buffer, size_t buffer_size);
@@ -70,5 +70,5 @@
  * @return Error code.
  */
-typedef errno_t (*usbvirt_on_data_from_device_t)(usbvirt_device_t *dev,
+typedef int (*usbvirt_on_data_from_device_t)(usbvirt_device_t *dev,
     usb_endpoint_t endpoint, usb_transfer_type_t transfer_type,
     void *buffer, size_t buffer_size, size_t *act_buffer_size);
@@ -85,5 +85,5 @@
  * @return Error code.
  */
-typedef errno_t (*usbvirt_on_control_t)(usbvirt_device_t *dev,
+typedef int (*usbvirt_on_control_t)(usbvirt_device_t *dev,
     const usb_device_request_setup_packet_t *setup_packet,
     uint8_t *data, size_t *act_data_size);
@@ -154,5 +154,5 @@
 	usb_standard_configuration_descriptor_t *descriptor;
 	/** Array of extra data. */
-	usbvirt_device_configuration_extras_t *extra;
+	const usbvirt_device_configuration_extras_t *extra;
 	/** Length of @c extra array. */
 	size_t extra_count;
@@ -239,9 +239,9 @@
 };
 
-extern errno_t req_nop(usbvirt_device_t *device,
+extern int req_nop(usbvirt_device_t *device,
     const usb_device_request_setup_packet_t *setup_packet,
     uint8_t *data, size_t *act_size);
 
-extern errno_t usbvirt_device_plug(usbvirt_device_t *, const char *);
+extern int usbvirt_device_plug(usbvirt_device_t *, const char *);
 extern void usbvirt_device_unplug(usbvirt_device_t *);
 
@@ -250,11 +250,11 @@
     const void *, size_t);
 
-extern errno_t usbvirt_control_write(usbvirt_device_t *, const void *, size_t,
+extern int usbvirt_control_write(usbvirt_device_t *, const void *, size_t,
     void *, size_t);
-extern errno_t usbvirt_control_read(usbvirt_device_t *, const void *, size_t,
+extern int usbvirt_control_read(usbvirt_device_t *, const void *, size_t,
     void *, size_t, size_t *);
-extern errno_t usbvirt_data_out(usbvirt_device_t *, usb_transfer_type_t,
+extern int usbvirt_data_out(usbvirt_device_t *, usb_transfer_type_t,
     usb_endpoint_t, const void *, size_t);
-extern errno_t usbvirt_data_in(usbvirt_device_t *, usb_transfer_type_t,
+extern int usbvirt_data_in(usbvirt_device_t *, usb_transfer_type_t,
     usb_endpoint_t, void *, size_t, size_t *);
 
Index: uspace/lib/usbvirt/include/usbvirt/ipc.h
===================================================================
--- uspace/lib/usbvirt/include/usbvirt/ipc.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usbvirt/include/usbvirt/ipc.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -54,11 +54,11 @@
 } usbvirt_hc_to_device_method_t;
 
-extern errno_t usbvirt_ipc_send_control_read(async_sess_t *, void *, size_t,
+extern int usbvirt_ipc_send_control_read(async_sess_t *, void *, size_t,
     void *, size_t, size_t *);
-extern errno_t usbvirt_ipc_send_control_write(async_sess_t *, void *, size_t,
+extern int usbvirt_ipc_send_control_write(async_sess_t *, void *, size_t,
     void *, size_t);
-extern errno_t usbvirt_ipc_send_data_in(async_sess_t *, usb_endpoint_t,
+extern int usbvirt_ipc_send_data_in(async_sess_t *, usb_endpoint_t,
     usb_transfer_type_t, void *, size_t, size_t *);
-extern errno_t usbvirt_ipc_send_data_out(async_sess_t *, usb_endpoint_t,
+extern int usbvirt_ipc_send_data_out(async_sess_t *, usb_endpoint_t,
     usb_transfer_type_t, void *, size_t);
 
Index: uspace/lib/usbvirt/include/usbvirt/virthub_base.h
===================================================================
--- uspace/lib/usbvirt/include/usbvirt/virthub_base.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usbvirt/include/usbvirt/virthub_base.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -56,5 +56,5 @@
 void *virthub_get_data(usbvirt_device_t *dev);
 
-errno_t virthub_base_init(virthub_base_t *instance,
+int virthub_base_init(virthub_base_t *instance,
     const char *name, usbvirt_device_ops_t *ops, void *data,
     const usb_standard_device_descriptor_t *device_desc,
@@ -63,12 +63,12 @@
 usb_address_t virthub_base_get_address(virthub_base_t *instance);
 
-errno_t virthub_base_request(virthub_base_t *instance, usb_target_t target,
+int virthub_base_request(virthub_base_t *instance, usb_target_t target,
     usb_direction_t dir, const usb_device_request_setup_packet_t *setup,
     void *buffer, size_t buffer_size, size_t *real_size);
 
-errno_t virthub_base_get_hub_descriptor(usbvirt_device_t *dev,
+int virthub_base_get_hub_descriptor(usbvirt_device_t *dev,
     const usb_device_request_setup_packet_t *request, uint8_t *data,
     size_t *act_size);
-errno_t virthub_base_get_null_status(usbvirt_device_t *dev,
+int virthub_base_get_null_status(usbvirt_device_t *dev,
     const usb_device_request_setup_packet_t *request, uint8_t *data,
     size_t *act_size);
Index: uspace/lib/usbvirt/src/ctrltransfer.c
===================================================================
--- uspace/lib/usbvirt/src/ctrltransfer.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usbvirt/src/ctrltransfer.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -49,5 +49,5 @@
  * @retval EFORWARD No suitable handler found.
  */
-errno_t process_control_transfer(usbvirt_device_t *dev,
+int process_control_transfer(usbvirt_device_t *dev,
     const usbvirt_control_request_handler_t *control_handlers,
     const usb_device_request_setup_packet_t *setup,
@@ -70,5 +70,5 @@
 		usb_log_debug("Control transfer: %s(%s)\n", handler->name,
 		    usb_debug_str_buffer((uint8_t*) setup, sizeof(*setup), 0));
-		errno_t rc = handler->callback(dev, setup, data, data_sent_size);
+		int rc = handler->callback(dev, setup, data, data_sent_size);
 		if (rc != EFORWARD) {
 			return rc;
Index: uspace/lib/usbvirt/src/device.c
===================================================================
--- uspace/lib/usbvirt/src/device.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usbvirt/src/device.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -82,5 +82,5 @@
  * @return Error code.
  */
-errno_t usbvirt_device_plug(usbvirt_device_t *dev, const char *vhc_path)
+int usbvirt_device_plug(usbvirt_device_t *dev, const char *vhc_path)
 {
 	if (DEV != NULL)
@@ -88,5 +88,5 @@
 	
 	devman_handle_t handle;
-	errno_t rc = devman_fun_get_handle(vhc_path, &handle, 0);
+	int rc = devman_fun_get_handle(vhc_path, &handle, 0);
 	if (rc != EOK)
 		return rc;
Index: uspace/lib/usbvirt/src/ipc_dev.c
===================================================================
--- uspace/lib/usbvirt/src/ipc_dev.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usbvirt/src/ipc_dev.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -81,5 +81,5 @@
     ipc_callid_t iid, ipc_call_t *icall)
 {
-	errno_t rc;
+	int rc;
 
 	void *setup_packet = NULL;
@@ -137,5 +137,5 @@
 {
 	size_t data_buffer_len = IPC_GET_ARG1(*icall);
-	errno_t rc;
+	int rc;
 
 	void *setup_packet = NULL;
@@ -183,5 +183,5 @@
 	usb_endpoint_t endpoint = IPC_GET_ARG1(*icall);
 
-	errno_t rc;
+	int rc;
 
 	size_t data_len = 0;
@@ -230,5 +230,5 @@
 	size_t data_buffer_size = 0;
 
-	errno_t rc = async_data_write_accept(&data_buffer, false,
+	int rc = async_data_write_accept(&data_buffer, false,
 	    1, 0, 0, &data_buffer_size);
 	if (rc != EOK) {
Index: uspace/lib/usbvirt/src/ipc_hc.c
===================================================================
--- uspace/lib/usbvirt/src/ipc_hc.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usbvirt/src/ipc_hc.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -55,5 +55,5 @@
  *
  */
-errno_t usbvirt_ipc_send_control_read(async_sess_t *sess, void *setup_buffer,
+int usbvirt_ipc_send_control_read(async_sess_t *sess, void *setup_buffer,
     size_t setup_buffer_size, void *data_buffer, size_t data_buffer_size,
     size_t *data_transfered_size)
@@ -77,5 +77,5 @@
 	}
 	
-	errno_t rc = async_data_write_start(exch, setup_buffer, setup_buffer_size);
+	int rc = async_data_write_start(exch, setup_buffer, setup_buffer_size);
 	if (rc != EOK) {
 		async_exchange_end(exch);
@@ -95,6 +95,6 @@
 	}
 	
-	errno_t data_request_rc;
-	errno_t opening_request_rc;
+	sysarg_t data_request_rc;
+	sysarg_t opening_request_rc;
 	async_wait_for(data_request, &data_request_rc);
 	async_wait_for(opening_request, &opening_request_rc);
@@ -103,11 +103,11 @@
 		/* Prefer the return code of the opening request. */
 		if (opening_request_rc != EOK)
-			return (errno_t) opening_request_rc;
+			return (int) opening_request_rc;
 		else
-			return (errno_t) data_request_rc;
+			return (int) data_request_rc;
 	}
 	
 	if (opening_request_rc != EOK)
-		return (errno_t) opening_request_rc;
+		return (int) opening_request_rc;
 	
 	if (data_transfered_size != NULL)
@@ -129,5 +129,5 @@
  *
  */
-errno_t usbvirt_ipc_send_control_write(async_sess_t *sess, void *setup_buffer,
+int usbvirt_ipc_send_control_write(async_sess_t *sess, void *setup_buffer,
     size_t setup_buffer_size, void *data_buffer, size_t data_buffer_size)
 {
@@ -150,5 +150,5 @@
 	}
 	
-	errno_t rc = async_data_write_start(exch, setup_buffer, setup_buffer_size);
+	int rc = async_data_write_start(exch, setup_buffer, setup_buffer_size);
 	if (rc != EOK) {
 		async_exchange_end(exch);
@@ -168,8 +168,8 @@
 	async_exchange_end(exch);
 	
-	errno_t opening_request_rc;
+	sysarg_t opening_request_rc;
 	async_wait_for(opening_request, &opening_request_rc);
 	
-	return (errno_t) opening_request_rc;
+	return (int) opening_request_rc;
 }
 
@@ -186,5 +186,5 @@
  *
  */
-errno_t usbvirt_ipc_send_data_in(async_sess_t *sess, usb_endpoint_t ep,
+int usbvirt_ipc_send_data_in(async_sess_t *sess, usb_endpoint_t ep,
     usb_transfer_type_t tr_type, void *data, size_t data_size, size_t *act_size)
 {
@@ -230,6 +230,6 @@
 	}
 	
-	errno_t data_request_rc;
-	errno_t opening_request_rc;
+	sysarg_t data_request_rc;
+	sysarg_t opening_request_rc;
 	async_wait_for(data_request, &data_request_rc);
 	async_wait_for(opening_request, &opening_request_rc);
@@ -238,11 +238,11 @@
 		/* Prefer the return code of the opening request. */
 		if (opening_request_rc != EOK)
-			return (errno_t) opening_request_rc;
+			return (int) opening_request_rc;
 		else
-			return (errno_t) data_request_rc;
+			return (int) data_request_rc;
 	}
 	
 	if (opening_request_rc != EOK)
-		return (errno_t) opening_request_rc;
+		return (int) opening_request_rc;
 	
 	if (act_size != NULL)
@@ -263,5 +263,5 @@
  *
  */
-errno_t usbvirt_ipc_send_data_out(async_sess_t *sess, usb_endpoint_t ep,
+int usbvirt_ipc_send_data_out(async_sess_t *sess, usb_endpoint_t ep,
     usb_transfer_type_t tr_type, void *data, size_t data_size)
 {
@@ -296,5 +296,5 @@
 	}
 	
-	errno_t rc = async_data_write_start(exch, data, data_size);
+	int rc = async_data_write_start(exch, data, data_size);
 	
 	async_exchange_end(exch);
@@ -305,8 +305,8 @@
 	}
 	
-	errno_t opening_request_rc;
+	sysarg_t opening_request_rc;
 	async_wait_for(opening_request, &opening_request_rc);
 	
-	return (errno_t) opening_request_rc;
+	return (int) opening_request_rc;
 }
 
Index: uspace/lib/usbvirt/src/private.h
===================================================================
--- uspace/lib/usbvirt/src/private.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usbvirt/src/private.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -38,5 +38,5 @@
 #include <usbvirt/device.h>
 
-errno_t process_control_transfer(usbvirt_device_t *,
+int process_control_transfer(usbvirt_device_t *,
     const usbvirt_control_request_handler_t *,
     const usb_device_request_setup_packet_t *,
Index: uspace/lib/usbvirt/src/stdreq.c
===================================================================
--- uspace/lib/usbvirt/src/stdreq.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usbvirt/src/stdreq.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -66,5 +66,5 @@
 
 /** NOP handler */
-errno_t req_nop(usbvirt_device_t *device,
+int req_nop(usbvirt_device_t *device,
     const usb_device_request_setup_packet_t *setup_packet,
     uint8_t *data, size_t *act_size)
@@ -74,5 +74,5 @@
 
 /** GET_DESCRIPTOR handler. */
-static errno_t req_get_descriptor(usbvirt_device_t *device,
+static int req_get_descriptor(usbvirt_device_t *device,
     const usb_device_request_setup_packet_t *setup_packet, uint8_t *data, size_t *act_size)
 {
@@ -135,5 +135,5 @@
 }
 
-static errno_t req_set_address(usbvirt_device_t *device,
+static int req_set_address(usbvirt_device_t *device,
     const usb_device_request_setup_packet_t *setup_packet, uint8_t *data, size_t *act_size)
 {
@@ -155,5 +155,5 @@
 }
 
-static errno_t req_set_configuration(usbvirt_device_t *device,
+static int req_set_configuration(usbvirt_device_t *device,
     const usb_device_request_setup_packet_t *setup_packet, uint8_t *data, size_t *act_size)
 {
@@ -197,5 +197,5 @@
 }
 
-static errno_t req_get_dev_status(usbvirt_device_t *device,
+static int req_get_dev_status(usbvirt_device_t *device,
     const usb_device_request_setup_packet_t *setup_packet, uint8_t *data, size_t *act_size)
 {
@@ -207,5 +207,5 @@
 	return EOK;
 }
-static errno_t req_get_iface_ep_status(usbvirt_device_t *device,
+static int req_get_iface_ep_status(usbvirt_device_t *device,
     const usb_device_request_setup_packet_t *setup_packet, uint8_t *data, size_t *act_size)
 {
Index: uspace/lib/usbvirt/src/transfer.c
===================================================================
--- uspace/lib/usbvirt/src/transfer.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usbvirt/src/transfer.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -50,5 +50,5 @@
  * @return Error code.
  */
-static errno_t usbvirt_control_transfer(usbvirt_device_t *dev,
+static int usbvirt_control_transfer(usbvirt_device_t *dev,
     const void *setup, size_t setup_size,
     void *data, size_t data_size, size_t *data_size_sent)
@@ -65,5 +65,5 @@
 	}
 
-	errno_t rc;
+	int rc;
 
 	/* Run user handler first. */
@@ -100,5 +100,5 @@
  * @return Error code.
  */
-errno_t usbvirt_control_write(usbvirt_device_t *dev, const void *setup,
+int usbvirt_control_write(usbvirt_device_t *dev, const void *setup,
     size_t setup_size, void *data, size_t data_size)
 {
@@ -119,5 +119,5 @@
  * @return Error code.
  */
-errno_t usbvirt_control_read(usbvirt_device_t *dev, const void *setup, size_t setup_size,
+int usbvirt_control_read(usbvirt_device_t *dev, const void *setup, size_t setup_size,
     void *data, size_t data_size, size_t *data_size_sent)
 {
@@ -135,5 +135,5 @@
  * @return Error code.
  */
-errno_t usbvirt_data_out(usbvirt_device_t *dev, usb_transfer_type_t transf_type,
+int usbvirt_data_out(usbvirt_device_t *dev, usb_transfer_type_t transf_type,
     usb_endpoint_t endpoint, const void *data, size_t data_size)
 {
@@ -145,5 +145,5 @@
 	}
 
-	errno_t rc = dev->ops->data_out[endpoint](dev, endpoint, transf_type,
+	int rc = dev->ops->data_out[endpoint](dev, endpoint, transf_type,
 	    data, data_size);
 
@@ -161,5 +161,5 @@
  * @return Error code.
  */
-errno_t usbvirt_data_in(usbvirt_device_t *dev, usb_transfer_type_t transf_type,
+int usbvirt_data_in(usbvirt_device_t *dev, usb_transfer_type_t transf_type,
     usb_endpoint_t endpoint, void *data, size_t data_size, size_t *data_size_sent)
 {
@@ -172,5 +172,5 @@
 
 	size_t data_size_sent_tmp;
-	errno_t rc = dev->ops->data_in[endpoint](dev, endpoint, transf_type,
+	int rc = dev->ops->data_in[endpoint](dev, endpoint, transf_type,
 	    data, data_size, &data_size_sent_tmp);
 
Index: uspace/lib/usbvirt/src/virthub_base.c
===================================================================
--- uspace/lib/usbvirt/src/virthub_base.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usbvirt/src/virthub_base.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -54,5 +54,5 @@
 }
 
-errno_t virthub_base_init(virthub_base_t *instance, const char *name,
+int virthub_base_init(virthub_base_t *instance, const char *name,
     usbvirt_device_ops_t *ops, void *data,
     const usb_standard_device_descriptor_t *device_desc,
@@ -109,5 +109,5 @@
 }
 
-errno_t virthub_base_request(virthub_base_t *instance, usb_target_t target,
+int virthub_base_request(virthub_base_t *instance, usb_target_t target,
     usb_direction_t dir, const usb_device_request_setup_packet_t *setup,
     void *buffer, size_t buffer_size, size_t *real_size)
@@ -143,5 +143,5 @@
 }
 
-errno_t virthub_base_get_hub_descriptor(usbvirt_device_t *dev,
+int virthub_base_get_hub_descriptor(usbvirt_device_t *dev,
     const usb_device_request_setup_packet_t *request, uint8_t *data,
     size_t *act_size)
@@ -159,5 +159,5 @@
 }
 
-errno_t virthub_base_get_null_status(usbvirt_device_t *dev,
+int virthub_base_get_null_status(usbvirt_device_t *dev,
     const usb_device_request_setup_packet_t *request, uint8_t *data,
     size_t *act_size)
Index: uspace/srv/audio/hound/audio_data.c
===================================================================
--- uspace/srv/audio/hound/audio_data.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/audio/hound/audio_data.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,5 +36,4 @@
 #include <macros.h>
 #include <stdlib.h>
-#include <str.h>
 
 #include "audio_data.h"
@@ -51,5 +50,5 @@
     pcm_format_t format)
 {
-	audio_data_t *adata = malloc(sizeof(audio_data_t) + size);
+	audio_data_t *adata = malloc(sizeof(audio_data_t));
 	if (adata) {
 		unsigned overflow = size % pcm_format_frame_size(&format);
@@ -57,6 +56,6 @@
 			log_warning("Data not a multiple of frame size, "
 			    "clipping.");
-		uint8_t *d = ((uint8_t *)adata) + offsetof(audio_data_t, data);
-		memcpy(d, data, size);
+
+		adata->data = data;
 		adata->size = size - overflow;
 		adata->format = format;
@@ -87,4 +86,5 @@
 	atomic_count_t refc = atomic_predec(&adata->refcount);
 	if (refc == 0) {
+		free(adata->data);
 		free(adata);
 	}
@@ -213,5 +213,5 @@
  * @return Error code.
  */
-errno_t audio_pipe_push(audio_pipe_t *pipe, audio_data_t *data)
+int audio_pipe_push(audio_pipe_t *pipe, audio_data_t *data)
 {
 	assert(pipe);
@@ -260,7 +260,7 @@
  * @param size Target buffer size.
  * @param format Target data format.
- * @return Size of the target buffer used.
- */
-size_t audio_pipe_mix_data(audio_pipe_t *pipe, void *data,
+ * @return Size of the target buffer used, Error code on failure.
+ */
+ssize_t audio_pipe_mix_data(audio_pipe_t *pipe, void *data,
     size_t size, const pcm_format_t *f)
 {
Index: uspace/srv/audio/hound/audio_data.h
===================================================================
--- uspace/srv/audio/hound/audio_data.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/audio/hound/audio_data.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -45,4 +45,6 @@
 /** Reference counted audio buffer */
 typedef struct {
+	/** Audio data */
+	const void *data;
 	/** Size of the buffer pointer to by data */
 	size_t size;
@@ -51,6 +53,4 @@
 	/** Reference counter */
 	atomic_t refcount;
-	/** Audio data */
-	const uint8_t data[];
 } audio_data_t;
 
@@ -75,8 +75,8 @@
 void audio_pipe_fini(audio_pipe_t *pipe);
 
-errno_t audio_pipe_push(audio_pipe_t *pipe, audio_data_t *data);
+int audio_pipe_push(audio_pipe_t *pipe, audio_data_t *data);
 audio_data_t *audio_pipe_pop(audio_pipe_t *pipe);
 
-size_t audio_pipe_mix_data(audio_pipe_t *pipe, void *buffer, size_t size,
+ssize_t audio_pipe_mix_data(audio_pipe_t *pipe, void *buffer, size_t size,
     const pcm_format_t *f);
 
@@ -113,10 +113,10 @@
  * Reference counted buffer is created automatically.
  */
-static inline errno_t audio_pipe_push_data(audio_pipe_t *pipe,
+static inline int audio_pipe_push_data(audio_pipe_t *pipe,
     const void *data, size_t size, pcm_format_t f)
 {
 	audio_data_t *adata = audio_data_create(data, size, f);
 	if (adata) {
-		const errno_t ret = audio_pipe_push(pipe, adata);
+		const int ret = audio_pipe_push(pipe, adata);
 		audio_data_unref(adata);
 		return ret;
